#include <bits/stdc++.h>

using namespace std;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    long long n, m, k, ans = 0;
    unordered_map<long long, long long> safety;
    unordered_map<long long, vector<long long>> paths;
    unordered_map<long long, long long> guards;
    vector <pair <long long, long long>> safest;

    cin >> n >> m >> k;

    for (long long i = 0; i < m; i++) {
        long long l, r;
        cin >> l >> r;
        paths[l].push_back(r);
        paths[r].push_back(l);
    }

    for (long long i = 0; i < k; i++) {
        long long p, h;
        cin >> p >> h;
        guards[p] = max(h + 1, guards[p]);
        if (safety[p] == 0) {
            ans++;
        }
        safety[p] = max(safety[p], h);
    }

    for (long long i = 1; i <= n; i++) {
        safest.push_back({safety[i], i});
    }

    sort(safest.begin(), safest.end());

    for (long long i = safest.size() - 1; i >= 0; i--) {
        long long ii = safest[i].second;
        if (guards[ii] > 0) {
            // BFS
            long long cur_h = guards[ii];
            vector <long long> children = {ii};

            while (!children.empty()) {
                vector<long long> new_children;

                for (long long j = 0; j < children.size(); j++) {
                    if (cur_h > 0 && safety[children[j]] == 0) {
                        ans++;
                    }
                    if (cur_h > safety[children[j]]) {
                        safety[children[j]] = cur_h;

                        for (long long q = 0; q < paths[children[j]].size(); q++) {
                            if (cur_h - 1 > safety[paths[children[j]][q]]) {
                                new_children.push_back(paths[children[j]][q]);
                            }
                        }
                    }
                }
                swap(children, new_children);
                cur_h--;
            }
        }
    }
    cout << ans << endl;
    for (long long i = 1; i <= n; i++) {
        if (safety[i] > 0) {
            cout << i << " ";
        }
    }
}
