#include <bits/stdc++.h>

using namespace std;


struct line {
    long double a, b, c;
};

struct dot {
    long double x, y;
};


line get_line(dot a, dot b) {
    line cur_line;
    if (a.x == b.x) {
        cur_line.a = 1;
        cur_line.b = 0;
        cur_line.c = -a.x;
    } else {
        cur_line.b = 1;
        cur_line.a = -(b.y - a.y) / (b.x - a.x);
        cur_line.c = -(cur_line.a * a.x + cur_line.b * a.y);
    }

    return cur_line;
}

line get_90_degree_line(line a, dot b) {
    line line_90_degree;
    if (a.a != 0) {
        line_90_degree.a = - 1 / a.a;
        line_90_degree.b = 1;
        line_90_degree.c = -(line_90_degree.a * b.x + line_90_degree.b * b.y);
    } else {
        line_90_degree.a = 1;
        line_90_degree.b = 0;
        line_90_degree.c = -b.x;
    }

    return line_90_degree;
}

line get_parallel_line(line a, dot b) {
    line parallel_line;
    parallel_line.a = a.a;
    parallel_line.b = a.b;
    parallel_line.c = -(a.a * b.x + a.b * b.y);

    return parallel_line;
}

dot get_line_cross_dot(line a, line b) {
    dot cur_dot;
    if (a.a == 0) {
        cur_dot.y = -a.c / a.b;
        cur_dot.x = -b.c / b.a;
    } else {
        if (b.a == 0) {
            cur_dot.y = -b.c / b.b;
            cur_dot.x = -a.c / a.a;
        } else {
            cur_dot.y = (b.a / a.a * a.c - b.c) / (b.b - b.a / a.a * a.b);
            if (a.b == 0) {
                cur_dot.x = -(b.b * cur_dot.y + b.c) / b.a;
            } else {
                cur_dot.x = -(a.b * cur_dot.y + a.c) / a.a;
            }
        }
    }
    return cur_dot;
}

long double get_length(dot a, dot b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    long long n;
    long double ans = 0;
    vector <dot> dots;

    cin >> n;

    for (long long i = 0; i < n; i++) {
        dot cur;
        cin >> cur.x >> cur.y;
        dots.push_back(cur);
    }

    ans += get_length(dots[0], dots[1]);

    line cur_line = get_line(dots[0], dots[1]);


    for (long long i = 2; i < n; i++) {
        long double x = dots[i].x, y = dots[i].y;
        if (x * cur_line.a + y * cur_line.b + cur_line.c == 0) {
            ans += get_length(dots[i - 1], dots[i]);
        } else {
            line cur_90_degree_line = get_90_degree_line(cur_line, dots[i - 1]);
            line parallel_line = get_parallel_line(cur_line, dots[i]);

            dot line_cross_dot = get_line_cross_dot(cur_90_degree_line, parallel_line);

            ans += get_length(dots[i - 1], line_cross_dot);
            ans += get_length(line_cross_dot, dots[i]);
            cur_line = parallel_line;
        }
    }
    cout << setprecision(30) << ans;
}
